| AI Engine Intrinsics User Guide (AIE) v2025.2

Loading...
Searching...
No Matches
Functions
16 bit Real x 16 bit Real
Intrinsics » Vector Operations » MAC intrinsics » Multiplication » Advanced » Integer » Vector MAC » 16 bit x 16 bit

## Overview

Vector MAC intrinsics with 16 bit real by 16 bit real

## Functions
v16acc48 | mac16 (v16acc48 acc, v32int16 xbuff, int xstart, unsigned int xoffsets, unsigned int xoffsets_hi, unsigned int xsquare, v16int16 zbuff, int zstart, unsigned int zoffsets, unsigned int zoffsets_hi, int zstep)
| Multiply-accumulate intrinsic function using small X input buffer.
v16acc48 | mac16 (v16acc48 acc, v64int16 xbuff, int xstart, unsigned int xoffsets, unsigned int xoffsets_hi, unsigned int xsquare, v16int16 zbuff, int zstart, unsigned int zoffsets, unsigned int zoffsets_hi, int zstep)
| Multiply-accumulate intrinsic function .
v8acc48 | mac8 (v8acc48 acc, v32int16 xbuff, int xstart, unsigned int xoffsets, int xstep, unsigned int xsquare, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Multiply-accumulate intrinsic function using small X input buffer.
v8acc48 | mac8 (v8acc48 acc, v64int16 xbuff, int xstart, unsigned int xoffsets, int xstep, unsigned int xsquare, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Multiply-accumulate intrinsic function .
v16acc48 | msc16 (v16acc48 acc, v32int16 xbuff, int xstart, unsigned int xoffsets, unsigned int xoffsets_hi, unsigned int xsquare, v16int16 zbuff, int zstart, unsigned int zoffsets, unsigned int zoffsets_hi, int zstep)
| Multiply-subtract intrinsic function using small X input buffer.
v16acc48 | msc16 (v16acc48 acc, v64int16 xbuff, int xstart, unsigned int xoffsets, unsigned int xoffsets_hi, unsigned int xsquare, v16int16 zbuff, int zstart, unsigned int zoffsets, unsigned int zoffsets_hi, int zstep)
| Multiply-subtract intrinsic function .
v8acc48 | msc8 (v8acc48 acc, v32int16 xbuff, int xstart, unsigned int xoffsets, int xstep, unsigned int xsquare, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Multiply-subtract intrinsic function using small X input buffer.
v8acc48 | msc8 (v8acc48 acc, v64int16 xbuff, int xstart, unsigned int xoffsets, int xstep, unsigned int xsquare, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Multiply-subtract intrinsic function .
v16acc48 | mul16 (v32int16 xbuff, int xstart, unsigned int xoffsets, unsigned int xoffsets_hi, unsigned int xsquare, v16int16 zbuff, int zstart, unsigned int zoffsets, unsigned int zoffsets_hi, int zstep)
| Multiply intrinsic function using small X input buffer.
v16acc48 | mul16 (v64int16 xbuff, int xstart, unsigned int xoffsets, unsigned int xoffsets_hi, unsigned int xsquare, v16int16 zbuff, int zstart, unsigned int zoffsets, unsigned int zoffsets_hi, int zstep)
| Multiply intrinsic function .
v8acc48 | mul8 (v32int16 xbuff, int xstart, unsigned int xoffsets, int xstep, unsigned int xsquare, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Multiply intrinsic function using small X input buffer.
v8acc48 | mul8 (v64int16 xbuff, int xstart, unsigned int xoffsets, int xstep, unsigned int xsquare, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Multiply intrinsic function .
v16acc48 | negmul16 (v32int16 xbuff, int xstart, unsigned int xoffsets, unsigned int xoffsets_hi, unsigned int xsquare, v16int16 zbuff, int zstart, unsigned int zoffsets, unsigned int zoffsets_hi, int zstep)
| Multiply-negate intrinsic function using small X input buffer.
v16acc48 | negmul16 (v64int16 xbuff, int xstart, unsigned int xoffsets, unsigned int xoffsets_hi, unsigned int xsquare, v16int16 zbuff, int zstart, unsigned int zoffsets, unsigned int zoffsets_hi, int zstep)
| Multiply-negate intrinsic function .
v8acc48 | negmul8 (v32int16 xbuff, int xstart, unsigned int xoffsets, int xstep, unsigned int xsquare, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Multiply-negate intrinsic function using small X input buffer.
v8acc48 | negmul8 (v64int16 xbuff, int xstart, unsigned int xoffsets, int xstep, unsigned int xsquare, v16int16 zbuff, int zstart, unsigned int zoffsets, int zstep)
| Multiply-negate intrinsic function .

## Function Documentation

## ◆ mac16() [1/2]

v16acc48 mac16 | ( | v16acc48 | acc,
|  | v32int16 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | unsigned int | xoffsets_hi,
|  | unsigned int | xsquare,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | unsigned int | zoffsets_hi,
|  | int | zstep
| ) |  |

Multiply-accumulate intrinsic function using small X input buffer.

acc0 += z00*x00 + z01*x01
acc1 += z10*x10 + z11*x11
acc2 += z20*x20 + z21*x21
acc3 += z30*x30 + z31*x31
acc4 += z40*x40 + z41*x41
acc5 += z50*x50 + z51*x51
acc6 += z60*x60 + z61*x61
acc7 += z70*x70 + z71*x71
acc8 += z80*x80 + z81*x81
acc9 += z90*x90 + z91*x91
acc10 += z100*x100 + z101*x101
acc11 += z110*x110 + z111*x111
acc12 += z120*x120 + z121*x121
acc13 += z130*x130 + z131*x131
acc14 += z140*x140 + z141*x141
acc15 += z150*x150 + z151*x151

Returns
  Returned accumulation vector (16 x int48 lanes)

Parameters

  acc | Incoming accumulation vector (16 x int48 lanes)
  xbuff | Input buffer of 32 elements of type int16
  xstart | Starting position offset applied to all lanes of input from X buffer. xstart is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xoffsets | 4b offset for each lane, corresponds to 2x the lane number and each second lane is an offset to the lane before + 1. LSB apply to first lane
  xoffsets_hi | 4b offset for each lane, corresponds to 2x the lane number and each second lane is an offset to the lane before + 1. LSB apply to 8th lane
  xsquare | Select order of the mini-permute square (default=0x3210). LSB apply to first element
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zoffsets_hi | 4b offset for each lane, applied to input from Z buffer. LSB apply to 8th lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - This intrinsic uses the 'square' parameter, to have more information on how to use this please go here
  - For more information on how data selection works from the buffers go here. For this intrinsic, the data buffer uses the 16bx16b scheme and the coefficient buffer uses the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mac16() [2/2]

v16acc48 mac16 | ( | v16acc48 | acc,
|  | v64int16 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | unsigned int | xoffsets_hi,
|  | unsigned int | xsquare,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | unsigned int | zoffsets_hi,
|  | int | zstep
| ) |  |

Multiply-accumulate intrinsic function .

acc0 += z00*x00 + z01*x01
acc1 += z10*x10 + z11*x11
acc2 += z20*x20 + z21*x21
acc3 += z30*x30 + z31*x31
acc4 += z40*x40 + z41*x41
acc5 += z50*x50 + z51*x51
acc6 += z60*x60 + z61*x61
acc7 += z70*x70 + z71*x71
acc8 += z80*x80 + z81*x81
acc9 += z90*x90 + z91*x91
acc10 += z100*x100 + z101*x101
acc11 += z110*x110 + z111*x111
acc12 += z120*x120 + z121*x121
acc13 += z130*x130 + z131*x131
acc14 += z140*x140 + z141*x141
acc15 += z150*x150 + z151*x151

Returns
  Returned accumulation vector (16 x int48 lanes)

Parameters

  acc | Incoming accumulation vector (16 x int48 lanes)
  xbuff | Input buffer of 64 elements of type int16
  xstart | Starting position offset applied to all lanes of input from X buffer. xstart is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xoffsets | 4b offset for each lane, corresponds to 2x the lane number and each second lane is an offset to the lane before + 1. LSB apply to first lane
  xoffsets_hi | 4b offset for each lane, corresponds to 2x the lane number and each second lane is an offset to the lane before + 1. LSB apply to 8th lane
  xsquare | Select order of the mini-permute square (default=0x3210). LSB apply to first element
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zoffsets_hi | 4b offset for each lane, applied to input from Z buffer. LSB apply to 8th lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - This intrinsic uses the 'square' parameter, to have more information on how to use this please go here
  - For more information on how data selection works from the buffers go here. For this intrinsic, the data buffer uses the 16bx16b scheme and the coefficient buffer uses the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mac8() [1/2]

v8acc48 mac8 | ( | v8acc48 | acc,
|  | v32int16 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | unsigned int | xsquare,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep
| ) |  |

Multiply-accumulate intrinsic function using small X input buffer.

acc0 += z00*x00 + z01*x01 + z02*x02 + z03*x03
acc1 += z10*x10 + z11*x11 + z12*x12 + z13*x13
acc2 += z20*x20 + z21*x21 + z22*x22 + z23*x23
acc3 += z30*x30 + z31*x31 + z32*x32 + z33*x33
acc4 += z40*x40 + z41*x41 + z42*x42 + z43*x43
acc5 += z50*x50 + z51*x51 + z52*x52 + z53*x53
acc6 += z60*x60 + z61*x61 + z62*x62 + z63*x63
acc7 += z70*x70 + z71*x71 + z72*x72 + z73*x73

Returns
  Returned accumulation vector (8 x int48 lanes)

Parameters

  acc | Incoming accumulation vector (8 x int48 lanes)
  xbuff | Input buffer of 32 elements of type int16
  xstart | Starting position offset applied to all lanes of input from X buffer. xstart is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xoffsets | 4b offset for each lane, while for each second lane, the offset is with respect to the previous lane + 1, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer. xstep is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xsquare | Select order of the mini-permute square (default=0x3210). LSB apply to first element
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - This intrinsic uses the 'square' parameter, to have more information on how to use this please go here
  - For more information on how data selection works from the buffers go here. For this intrinsic, the data buffer uses the 16bx16b scheme and the coefficient buffer uses the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mac8() [2/2]

v8acc48 mac8 | ( | v8acc48 | acc,
|  | v64int16 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | unsigned int | xsquare,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep
| ) |  |

Multiply-accumulate intrinsic function .

acc0 += z00*x00 + z01*x01 + z02*x02 + z03*x03
acc1 += z10*x10 + z11*x11 + z12*x12 + z13*x13
acc2 += z20*x20 + z21*x21 + z22*x22 + z23*x23
acc3 += z30*x30 + z31*x31 + z32*x32 + z33*x33
acc4 += z40*x40 + z41*x41 + z42*x42 + z43*x43
acc5 += z50*x50 + z51*x51 + z52*x52 + z53*x53
acc6 += z60*x60 + z61*x61 + z62*x62 + z63*x63
acc7 += z70*x70 + z71*x71 + z72*x72 + z73*x73

Returns
  Returned accumulation vector (8 x int48 lanes)

Parameters

  acc | Incoming accumulation vector (8 x int48 lanes)
  xbuff | Input buffer of 64 elements of type int16
  xstart | Starting position offset applied to all lanes of input from X buffer. xstart is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xoffsets | 4b offset for each lane, while for each second lane, the offset is with respect to the previous lane + 1, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer. xstep is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xsquare | Select order of the mini-permute square (default=0x3210). LSB apply to first element
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - This intrinsic uses the 'square' parameter, to have more information on how to use this please go here
  - For more information on how data selection works from the buffers go here. For this intrinsic, the data buffer uses the 16bx16b scheme and the coefficient buffer uses the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ msc16() [1/2]

v16acc48 msc16 | ( | v16acc48 | acc,
|  | v32int16 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | unsigned int | xoffsets_hi,
|  | unsigned int | xsquare,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | unsigned int | zoffsets_hi,
|  | int | zstep
| ) |  |

Multiply-subtract intrinsic function using small X input buffer.

acc0 -= z00*x00 + z01*x01
acc1 -= z10*x10 + z11*x11
acc2 -= z20*x20 + z21*x21
acc3 -= z30*x30 + z31*x31
acc4 -= z40*x40 + z41*x41
acc5 -= z50*x50 + z51*x51
acc6 -= z60*x60 + z61*x61
acc7 -= z70*x70 + z71*x71
acc8 -= z80*x80 + z81*x81
acc9 -= z90*x90 + z91*x91
acc10 -= z100*x100 + z101*x101
acc11 -= z110*x110 + z111*x111
acc12 -= z120*x120 + z121*x121
acc13 -= z130*x130 + z131*x131
acc14 -= z140*x140 + z141*x141
acc15 -= z150*x150 + z151*x151

Returns
  Returned accumulation vector (16 x int48 lanes)

Parameters

  acc | Incoming accumulation vector (16 x int48 lanes)
  xbuff | Input buffer of 32 elements of type int16
  xstart | Starting position offset applied to all lanes of input from X buffer. xstart is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xoffsets | 4b offset for each lane, corresponds to 2x the lane number and each second lane is an offset to the lane before + 1. LSB apply to first lane
  xoffsets_hi | 4b offset for each lane, corresponds to 2x the lane number and each second lane is an offset to the lane before + 1. LSB apply to 8th lane
  xsquare | Select order of the mini-permute square (default=0x3210). LSB apply to first element
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zoffsets_hi | 4b offset for each lane, applied to input from Z buffer. LSB apply to 8th lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - This intrinsic uses the 'square' parameter, to have more information on how to use this please go here
  - For more information on how data selection works from the buffers go here. For this intrinsic, the data buffer uses the 16bx16b scheme and the coefficient buffer uses the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ msc16() [2/2]

v16acc48 msc16 | ( | v16acc48 | acc,
|  | v64int16 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | unsigned int | xoffsets_hi,
|  | unsigned int | xsquare,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | unsigned int | zoffsets_hi,
|  | int | zstep
| ) |  |

Multiply-subtract intrinsic function .

acc0 -= z00*x00 + z01*x01
acc1 -= z10*x10 + z11*x11
acc2 -= z20*x20 + z21*x21
acc3 -= z30*x30 + z31*x31
acc4 -= z40*x40 + z41*x41
acc5 -= z50*x50 + z51*x51
acc6 -= z60*x60 + z61*x61
acc7 -= z70*x70 + z71*x71
acc8 -= z80*x80 + z81*x81
acc9 -= z90*x90 + z91*x91
acc10 -= z100*x100 + z101*x101
acc11 -= z110*x110 + z111*x111
acc12 -= z120*x120 + z121*x121
acc13 -= z130*x130 + z131*x131
acc14 -= z140*x140 + z141*x141
acc15 -= z150*x150 + z151*x151

Returns
  Returned accumulation vector (16 x int48 lanes)

Parameters

  acc | Incoming accumulation vector (16 x int48 lanes)
  xbuff | Input buffer of 64 elements of type int16
  xstart | Starting position offset applied to all lanes of input from X buffer. xstart is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xoffsets | 4b offset for each lane, corresponds to 2x the lane number and each second lane is an offset to the lane before + 1. LSB apply to first lane
  xoffsets_hi | 4b offset for each lane, corresponds to 2x the lane number and each second lane is an offset to the lane before + 1. LSB apply to 8th lane
  xsquare | Select order of the mini-permute square (default=0x3210). LSB apply to first element
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zoffsets_hi | 4b offset for each lane, applied to input from Z buffer. LSB apply to 8th lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - This intrinsic uses the 'square' parameter, to have more information on how to use this please go here
  - For more information on how data selection works from the buffers go here. For this intrinsic, the data buffer uses the 16bx16b scheme and the coefficient buffer uses the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ msc8() [1/2]

v8acc48 msc8 | ( | v8acc48 | acc,
|  | v32int16 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | unsigned int | xsquare,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep
| ) |  |

Multiply-subtract intrinsic function using small X input buffer.

acc0 -= z00*x00 + z01*x01 + z02*x02 + z03*x03
acc1 -= z10*x10 + z11*x11 + z12*x12 + z13*x13
acc2 -= z20*x20 + z21*x21 + z22*x22 + z23*x23
acc3 -= z30*x30 + z31*x31 + z32*x32 + z33*x33
acc4 -= z40*x40 + z41*x41 + z42*x42 + z43*x43
acc5 -= z50*x50 + z51*x51 + z52*x52 + z53*x53
acc6 -= z60*x60 + z61*x61 + z62*x62 + z63*x63
acc7 -= z70*x70 + z71*x71 + z72*x72 + z73*x73

Returns
  Returned accumulation vector (8 x int48 lanes)

Parameters

  acc | Incoming accumulation vector (8 x int48 lanes)
  xbuff | Input buffer of 32 elements of type int16
  xstart | Starting position offset applied to all lanes of input from X buffer. xstart is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xoffsets | 4b offset for each lane, while for each second lane, the offset is with respect to the previous lane + 1, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer. xstep is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xsquare | Select order of the mini-permute square (default=0x3210). LSB apply to first element
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - This intrinsic uses the 'square' parameter, to have more information on how to use this please go here
  - For more information on how data selection works from the buffers go here. For this intrinsic, the data buffer uses the 16bx16b scheme and the coefficient buffer uses the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ msc8() [2/2]

v8acc48 msc8 | ( | v8acc48 | acc,
|  | v64int16 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | unsigned int | xsquare,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep
| ) |  |

Multiply-subtract intrinsic function .

acc0 -= z00*x00 + z01*x01 + z02*x02 + z03*x03
acc1 -= z10*x10 + z11*x11 + z12*x12 + z13*x13
acc2 -= z20*x20 + z21*x21 + z22*x22 + z23*x23
acc3 -= z30*x30 + z31*x31 + z32*x32 + z33*x33
acc4 -= z40*x40 + z41*x41 + z42*x42 + z43*x43
acc5 -= z50*x50 + z51*x51 + z52*x52 + z53*x53
acc6 -= z60*x60 + z61*x61 + z62*x62 + z63*x63
acc7 -= z70*x70 + z71*x71 + z72*x72 + z73*x73

Returns
  Returned accumulation vector (8 x int48 lanes)

Parameters

  acc | Incoming accumulation vector (8 x int48 lanes)
  xbuff | Input buffer of 64 elements of type int16
  xstart | Starting position offset applied to all lanes of input from X buffer. xstart is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xoffsets | 4b offset for each lane, while for each second lane, the offset is with respect to the previous lane + 1, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer. xstep is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xsquare | Select order of the mini-permute square (default=0x3210). LSB apply to first element
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - This intrinsic uses the 'square' parameter, to have more information on how to use this please go here
  - For more information on how data selection works from the buffers go here. For this intrinsic, the data buffer uses the 16bx16b scheme and the coefficient buffer uses the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mul16() [1/2]

v16acc48 mul16 | ( | v32int16 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | unsigned int | xoffsets_hi,
|  | unsigned int | xsquare,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | unsigned int | zoffsets_hi,
|  | int | zstep
| ) |  |

Multiply intrinsic function using small X input buffer.

acc0 = z00*x00 + z01*x01
acc1 = z10*x10 + z11*x11
acc2 = z20*x20 + z21*x21
acc3 = z30*x30 + z31*x31
acc4 = z40*x40 + z41*x41
acc5 = z50*x50 + z51*x51
acc6 = z60*x60 + z61*x61
acc7 = z70*x70 + z71*x71
acc8 = z80*x80 + z81*x81
acc9 = z90*x90 + z91*x91
acc10 = z100*x100 + z101*x101
acc11 = z110*x110 + z111*x111
acc12 = z120*x120 + z121*x121
acc13 = z130*x130 + z131*x131
acc14 = z140*x140 + z141*x141
acc15 = z150*x150 + z151*x151

Returns
  Returned accumulation vector (16 x int48 lanes)

Parameters

  xbuff | Input buffer of 32 elements of type int16
  xstart | Starting position offset applied to all lanes of input from X buffer. xstart is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xoffsets | 4b offset for each lane, corresponds to 2x the lane number and each second lane is an offset to the lane before + 1. LSB apply to first lane
  xoffsets_hi | 4b offset for each lane, corresponds to 2x the lane number and each second lane is an offset to the lane before + 1. LSB apply to 8th lane
  xsquare | Select order of the mini-permute square (default=0x3210). LSB apply to first element
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zoffsets_hi | 4b offset for each lane, applied to input from Z buffer. LSB apply to 8th lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - This intrinsic uses the 'square' parameter, to have more information on how to use this please go here
  - For more information on how data selection works from the buffers go here. For this intrinsic, the data buffer uses the 16bx16b scheme and the coefficient buffer uses the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mul16() [2/2]

v16acc48 mul16 | ( | v64int16 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | unsigned int | xoffsets_hi,
|  | unsigned int | xsquare,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | unsigned int | zoffsets_hi,
|  | int | zstep
| ) |  |

Multiply intrinsic function .

acc0 = z00*x00 + z01*x01
acc1 = z10*x10 + z11*x11
acc2 = z20*x20 + z21*x21
acc3 = z30*x30 + z31*x31
acc4 = z40*x40 + z41*x41
acc5 = z50*x50 + z51*x51
acc6 = z60*x60 + z61*x61
acc7 = z70*x70 + z71*x71
acc8 = z80*x80 + z81*x81
acc9 = z90*x90 + z91*x91
acc10 = z100*x100 + z101*x101
acc11 = z110*x110 + z111*x111
acc12 = z120*x120 + z121*x121
acc13 = z130*x130 + z131*x131
acc14 = z140*x140 + z141*x141
acc15 = z150*x150 + z151*x151

Returns
  Returned accumulation vector (16 x int48 lanes)

Parameters

  xbuff | Input buffer of 64 elements of type int16
  xstart | Starting position offset applied to all lanes of input from X buffer. xstart is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xoffsets | 4b offset for each lane, corresponds to 2x the lane number and each second lane is an offset to the lane before + 1. LSB apply to first lane
  xoffsets_hi | 4b offset for each lane, corresponds to 2x the lane number and each second lane is an offset to the lane before + 1. LSB apply to 8th lane
  xsquare | Select order of the mini-permute square (default=0x3210). LSB apply to first element
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zoffsets_hi | 4b offset for each lane, applied to input from Z buffer. LSB apply to 8th lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - This intrinsic uses the 'square' parameter, to have more information on how to use this please go here
  - For more information on how data selection works from the buffers go here. For this intrinsic, the data buffer uses the 16bx16b scheme and the coefficient buffer uses the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mul8() [1/2]

v8acc48 mul8 | ( | v32int16 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | unsigned int | xsquare,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep
| ) |  |

Multiply intrinsic function using small X input buffer.

acc0 = z00*x00 + z01*x01 + z02*x02 + z03*x03
acc1 = z10*x10 + z11*x11 + z12*x12 + z13*x13
acc2 = z20*x20 + z21*x21 + z22*x22 + z23*x23
acc3 = z30*x30 + z31*x31 + z32*x32 + z33*x33
acc4 = z40*x40 + z41*x41 + z42*x42 + z43*x43
acc5 = z50*x50 + z51*x51 + z52*x52 + z53*x53
acc6 = z60*x60 + z61*x61 + z62*x62 + z63*x63
acc7 = z70*x70 + z71*x71 + z72*x72 + z73*x73

Returns
  Returned accumulation vector (8 x int48 lanes)

Parameters

  xbuff | Input buffer of 32 elements of type int16
  xstart | Starting position offset applied to all lanes of input from X buffer. xstart is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xoffsets | 4b offset for each lane, while for each second lane, the offset is with respect to the previous lane + 1, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer. xstep is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xsquare | Select order of the mini-permute square (default=0x3210). LSB apply to first element
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - This intrinsic uses the 'square' parameter, to have more information on how to use this please go here
  - For more information on how data selection works from the buffers go here. For this intrinsic, the data buffer uses the 16bx16b scheme and the coefficient buffer uses the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ mul8() [2/2]

v8acc48 mul8 | ( | v64int16 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | unsigned int | xsquare,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep
| ) |  |

Multiply intrinsic function .

acc0 = z00*x00 + z01*x01 + z02*x02 + z03*x03
acc1 = z10*x10 + z11*x11 + z12*x12 + z13*x13
acc2 = z20*x20 + z21*x21 + z22*x22 + z23*x23
acc3 = z30*x30 + z31*x31 + z32*x32 + z33*x33
acc4 = z40*x40 + z41*x41 + z42*x42 + z43*x43
acc5 = z50*x50 + z51*x51 + z52*x52 + z53*x53
acc6 = z60*x60 + z61*x61 + z62*x62 + z63*x63
acc7 = z70*x70 + z71*x71 + z72*x72 + z73*x73

Returns
  Returned accumulation vector (8 x int48 lanes)

Parameters

  xbuff | Input buffer of 64 elements of type int16
  xstart | Starting position offset applied to all lanes of input from X buffer. xstart is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xoffsets | 4b offset for each lane, while for each second lane, the offset is with respect to the previous lane + 1, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer. xstep is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xsquare | Select order of the mini-permute square (default=0x3210). LSB apply to first element
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - This intrinsic uses the 'square' parameter, to have more information on how to use this please go here
  - For more information on how data selection works from the buffers go here. For this intrinsic, the data buffer uses the 16bx16b scheme and the coefficient buffer uses the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ negmul16() [1/2]

v16acc48 negmul16 | ( | v32int16 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | unsigned int | xoffsets_hi,
|  | unsigned int | xsquare,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | unsigned int | zoffsets_hi,
|  | int | zstep
| ) |  |

Multiply-negate intrinsic function using small X input buffer.

acc0 = -( z00*x00 + z01*x01 )
acc1 = -( z10*x10 + z11*x11 )
acc2 = -( z20*x20 + z21*x21 )
acc3 = -( z30*x30 + z31*x31 )
acc4 = -( z40*x40 + z41*x41 )
acc5 = -( z50*x50 + z51*x51 )
acc6 = -( z60*x60 + z61*x61 )
acc7 = -( z70*x70 + z71*x71 )
acc8 = -( z80*x80 + z81*x81 )
acc9 = -( z90*x90 + z91*x91 )
acc10 = -( z100*x100 + z101*x101 )
acc11 = -( z110*x110 + z111*x111 )
acc12 = -( z120*x120 + z121*x121 )
acc13 = -( z130*x130 + z131*x131 )
acc14 = -( z140*x140 + z141*x141 )
acc15 = -( z150*x150 + z151*x151 )

Returns
  Returned accumulation vector (16 x int48 lanes)

Parameters

  xbuff | Input buffer of 32 elements of type int16
  xstart | Starting position offset applied to all lanes of input from X buffer. xstart is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xoffsets | 4b offset for each lane, corresponds to 2x the lane number and each second lane is an offset to the lane before + 1. LSB apply to first lane
  xoffsets_hi | 4b offset for each lane, corresponds to 2x the lane number and each second lane is an offset to the lane before + 1. LSB apply to 8th lane
  xsquare | Select order of the mini-permute square (default=0x3210). LSB apply to first element
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zoffsets_hi | 4b offset for each lane, applied to input from Z buffer. LSB apply to 8th lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - This intrinsic uses the 'square' parameter, to have more information on how to use this please go here
  - For more information on how data selection works from the buffers go here. For this intrinsic, the data buffer uses the 16bx16b scheme and the coefficient buffer uses the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ negmul16() [2/2]

v16acc48 negmul16 | ( | v64int16 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | unsigned int | xoffsets_hi,
|  | unsigned int | xsquare,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | unsigned int | zoffsets_hi,
|  | int | zstep
| ) |  |

Multiply-negate intrinsic function .

acc0 = -( z00*x00 + z01*x01 )
acc1 = -( z10*x10 + z11*x11 )
acc2 = -( z20*x20 + z21*x21 )
acc3 = -( z30*x30 + z31*x31 )
acc4 = -( z40*x40 + z41*x41 )
acc5 = -( z50*x50 + z51*x51 )
acc6 = -( z60*x60 + z61*x61 )
acc7 = -( z70*x70 + z71*x71 )
acc8 = -( z80*x80 + z81*x81 )
acc9 = -( z90*x90 + z91*x91 )
acc10 = -( z100*x100 + z101*x101 )
acc11 = -( z110*x110 + z111*x111 )
acc12 = -( z120*x120 + z121*x121 )
acc13 = -( z130*x130 + z131*x131 )
acc14 = -( z140*x140 + z141*x141 )
acc15 = -( z150*x150 + z151*x151 )

Returns
  Returned accumulation vector (16 x int48 lanes)

Parameters

  xbuff | Input buffer of 64 elements of type int16
  xstart | Starting position offset applied to all lanes of input from X buffer. xstart is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xoffsets | 4b offset for each lane, corresponds to 2x the lane number and each second lane is an offset to the lane before + 1. LSB apply to first lane
  xoffsets_hi | 4b offset for each lane, corresponds to 2x the lane number and each second lane is an offset to the lane before + 1. LSB apply to 8th lane
  xsquare | Select order of the mini-permute square (default=0x3210). LSB apply to first element
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zoffsets_hi | 4b offset for each lane, applied to input from Z buffer. LSB apply to 8th lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - This intrinsic uses the 'square' parameter, to have more information on how to use this please go here
  - For more information on how data selection works from the buffers go here. For this intrinsic, the data buffer uses the 16bx16b scheme and the coefficient buffer uses the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ negmul8() [1/2]

v8acc48 negmul8 | ( | v32int16 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | unsigned int | xsquare,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep
| ) |  |

Multiply-negate intrinsic function using small X input buffer.

acc0 = -( z00*x00 + z01*x01 + z02*x02 + z03*x03 )
acc1 = -( z10*x10 + z11*x11 + z12*x12 + z13*x13 )
acc2 = -( z20*x20 + z21*x21 + z22*x22 + z23*x23 )
acc3 = -( z30*x30 + z31*x31 + z32*x32 + z33*x33 )
acc4 = -( z40*x40 + z41*x41 + z42*x42 + z43*x43 )
acc5 = -( z50*x50 + z51*x51 + z52*x52 + z53*x53 )
acc6 = -( z60*x60 + z61*x61 + z62*x62 + z63*x63 )
acc7 = -( z70*x70 + z71*x71 + z72*x72 + z73*x73 )

Returns
  Returned accumulation vector (8 x int48 lanes)

Parameters

  xbuff | Input buffer of 32 elements of type int16
  xstart | Starting position offset applied to all lanes of input from X buffer. xstart is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xoffsets | 4b offset for each lane, while for each second lane, the offset is with respect to the previous lane + 1, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer. xstep is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xsquare | Select order of the mini-permute square (default=0x3210). LSB apply to first element
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - This intrinsic uses the 'square' parameter, to have more information on how to use this please go here
  - For more information on how data selection works from the buffers go here. For this intrinsic, the data buffer uses the 16bx16b scheme and the coefficient buffer uses the general scheme.
  - Parameter 'zstart' must be a compile time constant.

## ◆ negmul8() [2/2]

v8acc48 negmul8 | ( | v64int16 | xbuff,
|  | int | xstart,
|  | unsigned int | xoffsets,
|  | int | xstep,
|  | unsigned int | xsquare,
|  | v16int16 | zbuff,
|  | int | zstart,
|  | unsigned int | zoffsets,
|  | int | zstep
| ) |  |

Multiply-negate intrinsic function .

acc0 = -( z00*x00 + z01*x01 + z02*x02 + z03*x03 )
acc1 = -( z10*x10 + z11*x11 + z12*x12 + z13*x13 )
acc2 = -( z20*x20 + z21*x21 + z22*x22 + z23*x23 )
acc3 = -( z30*x30 + z31*x31 + z32*x32 + z33*x33 )
acc4 = -( z40*x40 + z41*x41 + z42*x42 + z43*x43 )
acc5 = -( z50*x50 + z51*x51 + z52*x52 + z53*x53 )
acc6 = -( z60*x60 + z61*x61 + z62*x62 + z63*x63 )
acc7 = -( z70*x70 + z71*x71 + z72*x72 + z73*x73 )

Returns
  Returned accumulation vector (8 x int48 lanes)

Parameters

  xbuff | Input buffer of 64 elements of type int16
  xstart | Starting position offset applied to all lanes of input from X buffer. xstart is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xoffsets | 4b offset for each lane, while for each second lane, the offset is with respect to the previous lane + 1, applied to the x buffer. LSB apply to first lane
  xstep | Step between each column for selection in the xbuffer. xstep is restricted to multiples of 2 as granularity for xbuff is 32-bit.
  xsquare | Select order of the mini-permute square (default=0x3210). LSB apply to first element
  zbuff | Input buffer of 16 elements of type int16
  zstart | Starting position offset applied to all lanes for input from Z buffer. This must be a compile time constant. Only the 4 LSB of the argument are used.
  zoffsets | 4b offset for each lane, applied to input from Z buffer. LSB apply to first lane
  zstep | Step between each column for selection in the zbuffer.

Note
  - This intrinsic uses the 'square' parameter, to have more information on how to use this please go here
  - For more information on how data selection works from the buffers go here. For this intrinsic, the data buffer uses the 16bx16b scheme and the coefficient buffer uses the general scheme.
  - Parameter 'zstart' must be a compile time constant.